#!/usr/bin/perl -w
use DBI;

#Before running FTP Indexer you should change these settings to your
#preferred values


#Global Config
$_debug=1;	#set to 1 for debugmessages (not recommended)
$_public=0;	#set to 1 to forbid adding or deleting servers
$_stylesheet="./style.css";        #Stylesheet to use

#Indexer Config
$_ftpls='/usr/local/bin/ftpls';    #full path to ftpls
$_reindex=5;			   #Reindex Server after howmany days?
$_retries=1;			   #Retries to Login (1 recommended)
$_lockfile='/tmp/indexer.pid';     #Lockfile - make sure your webserver-user has write
                                   #access
$_minsize=1024*1024;     	   #Minimum size for files to be indexed
$_maxprocs=15;                     #Maximum number of simultanous processes

#Include all the file-endings you want to have listed (case is ignored)
@_filetypes = ('rar','r[0-9][0-9]','avi','mpg','mpeg','zip','mp3','ace','c[0-9][0-9]',
               'exe','gz','z','tar','lzh','tgz','iso','wma','wmv','asf','pdf','nfo',
	       'rm','ram','mov','arj','sit','hqx','lha','adf','prc','pdb');
#@_filetypes=undef;		   #uncomment this to index all files (not recommended)


#Search Config
$_results=20;			#How much results to display per page?
$_maxchar=60;			#Howmany chars of the resultfile should be displayed
$_sortby="Date DESC,ServerName";#Order of the results
                                #Valid choices are: ServerName, User, Password,
				#                   LastConnect, FileName, Date, Size
				#You may use DESC to reverse the order


#databaseinfo:
$_db_type="mysql";		#The DBI-Driver
$_db_name="ftpindex";		#Name of Database
$_db_host="localhost";		#Databasehost
$_db_port="3306";		#Databaseport
$_db_user="www";		#User to connect to Database
$_db_pass="leech";		#Passwort for above user








#-----------------------------------------------------------------------------
#- NO CHANGES NEEDED BELOW ----------------------------------------------------
#-----------------------------------------------------------------------------

#print htmlheader
# You should modify this procedure for changing the design
# eg. Add your own CSS etc.
sub header($){
  my $dbh = newdbh();
  my $result = $dbh->selectall_arrayref("SELECT COUNT(*) FROM Server");
  my $servercount = $result->[0][0];
     $result = $dbh->selectall_arrayref("SELECT COUNT(*) FROM Files");
  my $filescount = $result->[0][0];
  $dbh->disconnect;

  #load stylesheet
  open (STYLE,$_stylesheet);
  my @style = <STYLE>;
  close (STYLE);

print <<ENDofHTML;

<HTML>
<HEAD>
<TITLE>$_[0]</TITLE>

@style

</HEAD>
<BODY>


<TABLE WIDTH="100%" CLASS="head_table">
<TR>
<TD>
    <FORM ACTION="search.cgi" METHOD="get">
       <B>Search for Filez</B><BR>
       <INPUT TYPE="text" NAME="q" VALUE="$q" SIZE="40">
       <INPUT TYPE="submit" VALUE="Search"><BR>
       <FONT SIZE="-1">
       <I>$servercount</I> servers with <I>$filescount</I> files in database
       </FONT>
    </FORM>
</TD>
<TD>
ENDofHTML
  if (!$_public){print '<A HREF="massadd.cgi" CLASS=\"head_links\">Add servers</A><BR>';}
print <<ENDofHTML;
   <A HREF="slurp.cgi" CLASS="head_links">Fetch servers from website</A><BR>
   <A HREF="export.cgi" CLASS="head_links">Show all servers</A><BR>
   <A HREF="README.html" CLASS="head_links">Readme</A>
</TD>
</TR>
</TABLE>

ENDofHTML
}

#-----------------------------------------------------------------------------
#- DON'T CHANGE ANYTHING BELOW -----------------------------------------------
#-----------------------------------------------------------------------------

# Subroutines below:

# Build regexp from filetypes:
if (defined(@_filetypes)){
  for $type (@_filetypes){
    $_pattern = $_pattern.'(^.*\.'.$type.'$)|';
  }
  chop $_pattern;
}else{
  $_pattern=undef;
}

# Return new databasehandle
sub newdbh(){
  return DBI->connect("dbi:".$_db_type.":".$_db_name.":".$_db_host.":".$_db_port,
                           $_db_user,$_db_pass) || die("Can't connect");
}

sub debug($){
  if ($_debug){
    my @time = localtime();
    my $clock = sprintf("%02d:%02d:%02d",$time[2],$time[1],$time[0]);
    print STDERR "[$$] DEBUG ($clock): ".$_[0]."\n";
  }
}

1; #return true
